INCLUDE \masm32\include\masm32rt.inc
.586
INCLUDE \masm32\macros\timers.asm

.data
buf BYTE 30 DUP(0)
negvals DWORD -9, -99, -999, -9999, -99999, -999999, -9999999, -99999999, -999999999, -1000000000
posvals DWORD  9,  99,  999,  9999,  99999,  999999,  9999999,  99999999,  999999999,  1000000000

.code
;  

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
;----------------------------------------------------------
;dwtoa2 by brethren using hutchs optimizations from utoa2
;----------------------------------------------------------
ALIGN 16
dwtoa2 PROC value:DWORD, szbuf:PTR BYTE
	push ebx
	push esi

	mov eax, [esp+12]		;value
	mov ebx, 0CCCCCCCDh
	mov esi, [esp+16]		;szbuf

	test eax, eax
	jge @F
	mov BYTE PTR [esi], '-'
	add esi, 1
	neg eax
@@:
	cmp eax, 9999
	ja lb4

	cmp eax, 999999
	ja lb6

	cmp eax, 9
	ja lb1
	add esi, 1
	jmp @F
lb1:
	cmp eax, 99
	ja lb2
	add esi, 2
	jmp @F
lb2:
	cmp eax, 999
	ja lb3
	add esi, 3
	jmp @F
lb3:
	cmp eax, 9999
	ja lb4
	add esi, 4
	jmp @F
lb4:
	cmp eax, 99999
	ja lb5
	add esi, 5
	jmp @F
lb5:
	cmp eax, 999999
	ja lb6
	add esi, 6
	jmp @F
lb6:
	cmp eax, 9999999
	ja lb7
	add esi, 7
	jmp @F
lb7:
	cmp eax, 99999999
	ja lb8
	add esi, 8
	jmp @F
lb8:
	cmp eax, 999999999
	ja lb9
	add esi, 9
	jmp @F
lb9:
	add esi, 10
@@:
	mov BYTE PTR [esi], NULL
	sub esi, 1
@@:	;loop unrolled twice
	mov ecx, eax
	mul ebx
	shr edx, 3
	mov eax, edx
	lea edx, [edx+edx*4]
	lea edx, [edx+edx-'0']
	sub ecx, edx
	mov [esi], cl
	sub esi, 1
	test eax, eax
	jbe done

	mov ecx, eax
	mul ebx
	shr edx, 3
	mov eax, edx
	lea edx, [edx+edx*4]
	lea edx, [edx+edx-'0']
	sub ecx, edx
	mov [esi], cl
	sub esi, 1
	test eax, eax
	ja @B
done:
	pop esi
	pop ebx
	ret 8
dwtoa2 ENDP

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
;----------------------------------------------------------
main PROC
	print "Timing positive conversions", 13, 10
	print "---------------------------", 13, 10
	print str$(posvals), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	print str$(posvals+4), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals+4, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals+4, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	print str$(posvals+8), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals+8, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals+8, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	print str$(posvals+12), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals+12, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals+12, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	print str$(posvals+16), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals+16, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals+16, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	print str$(posvals+20), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals+20, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals+20, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	print str$(posvals+24), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals+24, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals+24, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	print str$(posvals+28), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals+28, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals+28, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	print str$(posvals+32), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals+32, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals+32, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	print str$(posvals+36), 13, 10
	print chr$("----------", 13, 10)
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, posvals+36, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, posvals+36, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13, 10, 10)

	inkey "--test finished--"
	exit
main ENDP
END main


